dofile("seaquest/lib/loadGraphics.lua")
-- ## carrega as imagens do jogo ## --
loadImages()

dofile("seaquest/lib/printFont.lua")
dofile("seaquest/lib/modClass.lua")
dofile("seaquest/lib/spriteClass.lua")
dofile("seaquest/lib/collisionDetect.lua")
dofile("seaquest/lib/gunClass.lua")

dofile("seaquest/lib/controleInimigos.lua")
dofile("seaquest/lib/oxigen.lua")
dofile("seaquest/lib/controleSubSuperficie.lua")
dofile("seaquest/lib/controleDificuldade.lua")
dofile("seaquest/lib/controlaMovimentoMar.lua")

dofile("seaquest/lib/fluxoGame.lua")
dofile("seaquest/lib/fluxoApresentacao.lua")
dofile("seaquest/lib/fluxoGameOver.lua")
habilitaDebug = false


-- ## verifica se o subamrino colidiu com os inimigos ## --
function verificaColisaoHero()
    local retornoFuncao = false
    -- ## verifica as colisoes do tiros com os inimigos ## --
	for n = 0, table.maxn(sprite) do
       if spriteCollided(hero,sprite[n]) then 
            retornoFuncao = true
       end
    end    
    return retornoFuncao
end



-- ## Cria o personagem principal ## --
--hero = Sprite:new(sub,SCREEN_UP,0,100,100,1,2,43,22,2)
hero = Sprite:new(submarino,SCREEN_UP,0,100,100,1,2,32,12,3,0)

-- ## controla as musicas do jogo ## --
--music = ModuleMusic:new("bog_wraith.bin",10)
--music:loadModule()
--music:play()


-- ## controla os tiros  ## --
tiro = Gun:new(tiroSubmarino,SCREEN_UP,3,4,hero) --> imagem,tela,velocidade,qtd balas, sprite origem
tiro:createBullets()


-- ## controla o fluxo de execucao do jogo ##--
-- ## 0- Logo DC
-- ## 1- apresentacao 
-- ## 2- jogo
-- ## 3- game over
fluxoExecucaoGame = 1


while not Keys.newPress.Start do
	Controls.read()

	startDrawing()

    if fluxoExecucaoGame == 1 then 
        fluxoApresentacao()
    end 
    
    if fluxoExecucaoGame == 2 then 
        fluxoGame()
    end

    if fluxoExecucaoGame == 3 then 
        fluxoGameOver()
    end


    
    -- ## imprime o logo da DC na parte de baixo da tela ## --
    screen.drawFillRect(SCREEN_DOWN, 0, 0, 256, 192, Color.new(31, 31, 31))
    screen.blit(SCREEN_DOWN,22,65,dcLogo)

	
    stopDrawing()
end

-- ## libera memoria alocada para as imagens ## --
freeImages()

posX = nil
posY = nil


