-- ## Collision Detect ## --
function spriteCollided(sprite1,sprite2)

    if habilitaDebug then 
        screen.print(SCREEN_DOWN, 100, 0, "Spr1 width :"..sprite1:getWidth())
        screen.print(SCREEN_DOWN, 100,10, "Spr1 height:"..sprite1:getHeight())
        screen.print(SCREEN_DOWN, 100,20, "Spr2 width :"..sprite2:getWidth())
        screen.print(SCREEN_DOWN, 100,30, "Spr2 height:"..sprite2:getHeight())
    end

    local retunStatus = false
    if sprite1.active and sprite2.active then  
        if (sprite2.posY >= sprite1.posY and sprite1.posY + sprite1.height >= sprite2.posY) or (sprite2.posY + sprite2.height >= sprite1.posY and sprite1.posY + sprite1.height >= sprite2.posY + sprite2.height) or (sprite1.posY >= sprite2.posY and sprite2.posY + sprite2.height >= sprite1.posY) or (sprite1.posY + sprite1.height >= sprite2.posY and sprite2.posY + sprite2.height >= sprite1.posY + sprite1.height) then
            -- corner 1 --
            if sprite2.posX >= sprite1.posX and sprite1.posX + sprite1.width >= sprite2.posX then
                retunStatus = true
            end
            -- corner 2 --
            if sprite2.posX + sprite2.width >= sprite1.posX and sprite1.posX + sprite1.width >= sprite2.posX + sprite2.width then
                retunStatus = true 
            end
            -- corner 3 --
            if sprite1.posX >= sprite2.posX and sprite2.posX + sprite2.width >= sprite1.posX then
                retunStatus = true  
            end
            -- corner 4 --
            if sprite1.posX + sprite1.width >= sprite2.posX and sprite2.posX + sprite2.width >= sprite1.posX + sprite1.width then
                retunStatus = true
            end	 
        end
    end 
    return retunStatus
end
