-- ## cuida da criacao dos inimigos ## -- 

-- ## Cria os sprites do jogo ## --
posicaoDuto0 = 60
posicaoDuto1 = 85
posicaoDuto2 = 115
posicaoDuto3 = 140
velocidadeInimigos = 0
ajustaDificuldade  = 0
pontuacaoInimigos  = 50
sprite = {}
	for i = 0, 3 do
        if i == 0 then posicaoY = posicaoDuto0 end 
        if i == 1 then posicaoY = posicaoDuto1 end 
        if i == 2 then posicaoY = posicaoDuto2 end 
        if i == 3 then posicaoY = posicaoDuto3 end 
        sprite[i] = Sprite:new(inimigoPeixe,SCREEN_UP,i,-100,posicaoY,0,velocidadeInimigos,16,8,3,pontuacaoInimigos)
        sprite[i].active = false
    end

--## Define estrtura de acesso para os iniigos ## --
duto = {}
duto[0] = false
duto[1] = false
duto[2] = false
duto[3] = false


-- ## insere os imigos nos dutos e seta sua velocidade e direcao ## -- 
function createInimigos()
	for d = 0, table.maxn(duto) do
        if not duto[d] then 

            duto[d] = true
            -- Como a rotina de desabilitar sprite desloca a pos X e Y do sprite para pontos negativos a posicao Y deve ser resetada para cada sprite -- 
            if d == 0 then posicaoY = posicaoDuto0 end 
            if d == 1 then posicaoY = posicaoDuto1 end 
            if d == 2 then posicaoY = posicaoDuto2 end 
            if d == 3 then posicaoY = posicaoDuto3 end
            -- atribui as propriedades do sprite --
            sprite[d].active    = true
            sprite[d].direction = rndDirecaoInimigo()
            sprite[d].speed     = velocidadeInimigos
            sprite[d].posY      = posicaoY
            if sprite[d].direction == 1 then 
                sprite[d].posX = 0
            else  
                sprite[d].posX = 272
            end
        end
    end
end 

-- ## destroi todos os inimigos da tela .. usado quando o submarino é atingido por um inimigo ## --
function destroiInimigos()
	for d = 0, table.maxn(duto) do
        if duto[d] then 
            duto[d] = false
            -- Como a rotina de desabilitar sprite desloca a pos X e Y do sprite para pontos negativos a posicao Y deve ser resetada para cada sprite -- 
            if d == 0 then posicaoY = posicaoDuto0 end 
            if d == 1 then posicaoY = posicaoDuto1 end 
            if d == 2 then posicaoY = posicaoDuto2 end 
            if d == 3 then posicaoY = posicaoDuto3 end
            -- atribui as propriedades do sprite --
            sprite[d].active    = false
            sprite[d].posY      = -100
            sprite[d].posX      = -100
        end
    end
end


-- ## sort da direcao em que o imigo ira se mover 0->esquerrda 1->direita ## --
function rndDirecaoInimigo()
    rndDirecao = math.random(1,4)
    if rndDirecao >= 3 then 
        sortDirecao = 1
    else
        sortDirecao = 0
    end
    return sortDirecao
end

-- ## movimenta inimigos ## --
function moveInimigos()
	for mi = 0, table.maxn(sprite) do
        sprite[mi]:AutoHorizontalMoviment(false)
        sprite[mi]:putSprite()
        if not sprite[mi].active then 
            duto[mi] = false 
        end
	end
end

-- ## Debug ## --
function debugInimigo()
    posicionaDebug = 50
	for dd = 0, table.maxn(duto) do
        if duto[dd] then 
            statusDuto = "ocupado"
        else
            statusDuto = "livre"
        end
        screen.print(SCREEN_DOWN, 0, posicionaDebug, "Duto " .. dd .. ": " .. statusDuto .. " SprX:" .. sprite[dd].posX .. " SprY:" .. sprite[dd].posY .. " D:" .. sprite[dd].direction)
        posicionaDebug = posicionaDebug + 10 
    end 
    screen.print(SCREEN_DOWN, 0, posicionaDebug + 50, "Velocidade: " .. velocidadeInimigos .. " AjusteDeficuldade: " .. ajustaDificuldade)
end

-- ## --------------------------------------- ## --
