-- ## cuida da criacao dos mergulhadores ## -- 

-- ## Cria os sprites do jogo ## --
velocidadeMergulhador = .5
pontuacaoMergulhador  = 20
sprMergulhador = {}
	for i2 = 0, 3 do
        if i2 == 0 then posicaoY = posicaoDuto0 end 
        if i2 == 1 then posicaoY = posicaoDuto1 end 
        if i2 == 2 then posicaoY = posicaoDuto2 end 
        if i2 == 3 then posicaoY = posicaoDuto3 end 
        sprMergulhador[i2] = Sprite:new(mergulhador,SCREEN_UP,i2,-100,posicaoY,0,velocidadeMergulhador,16,16,3,pontuacaoMergulhador)
        sprMergulhador[i2].active = false
    end

--## Define estrtura de acesso para os iniigos ## --
dutoMergulhador = {}
dutoMergulhador[0] = false
dutoMergulhador[1] = false
dutoMergulhador[2] = false
dutoMergulhador[3] = false

-- ## Cria os mergulhadores ## --
function createMergulhador()
    rndCriaMergulhador = math.random(1,50)
    if rndCriaMergulhador >= 33 and rndCriaMergulhador <= 43 then
        rndDutoMergulhador = math.random(0,3)
        if not dutoMergulhador[rndDutoMergulhador] then 
            dutoMergulhador[rndDutoMergulhador]       = true
            sprMergulhador[rndDutoMergulhador].active = true
            sprMergulhador[rndDutoMergulhador].speed  = velocidadeMergulhador
            sprMergulhador[rndDutoMergulhador].direction = rndDirecaoMergulhador()
            if sprMergulhador[rndDutoMergulhador].direction == 1 then   
                sprMergulhador[rndDutoMergulhador].posX = 0
            else
                sprMergulhador[rndDutoMergulhador].posX = 272
            end

            if rndDutoMergulhador == 0 then sprMergulhador[rndDutoMergulhador].posY = posicaoDuto0 end 
            if rndDutoMergulhador == 1 then sprMergulhador[rndDutoMergulhador].posY = posicaoDuto1 end 
            if rndDutoMergulhador == 2 then sprMergulhador[rndDutoMergulhador].posY = posicaoDuto2 end 
            if rndDutoMergulhador == 3 then sprMergulhador[rndDutoMergulhador].posY = posicaoDuto3 end

        end 
    end  
end

-- ## sort da direcao em que o imigo ira se mover 0->esquerrda 1->direita ## --
function rndDirecaoMergulhador()
    rndDirMergulhador = math.random(1,4)
    if rndDirMergulhador >= 3 then 
        sortDirMergulhador = 1
    else
        sortDirMergulhador = 0
    end
    return sortDirMergulhador
end


-- ## destroi todos os inimigos da tela .. usado quando o submarino  atingido por um inimigo ## --
function resgataMergulhador(numMergulhador)
	-- ## limpa todos os mergulhadores da tela ## --
    if numMergulhador == 99 then 
        for dm = 0, table.maxn(dutoMergulhador) do
            if dutoMergulhador[dm] then 
                dutoMergulhador[dm] = false
                sprMergulhador[dm].active    = false
                -- Como a rotina de desabilitar sprite desloca a pos X e Y do sprite para pontos negativos a posicao Y deve ser resetada para cada sprite -- 
                if dm == 0 then sprMergulhador[dm].posY = posicaoDuto0 end 
                if dm == 1 then sprMergulhador[dm].posY = posicaoDuto1 end 
                if dm == 2 then sprMergulhador[dm].posY = posicaoDuto2 end 
                if dm == 3 then sprMergulhador[dm].posY = posicaoDuto3 end
                sprMergulhador[dm].posX      = -100
            end
        end
    else
        -- ## resgata mergulhador especifico
        if dutoMergulhador[numMergulhador] then 
            dutoMergulhador[numMergulhador]       = false
            sprMergulhador[numMergulhador].active = false
            -- Como a rotina de desabilitar sprite desloca a pos X e Y do sprite para pontos negativos a posicao Y deve ser resetada para cada sprite -- 
            if numMergulhador == 0 then sprMergulhador[numMergulhador].posY = posicaoDuto0 end 
            if numMergulhador == 1 then sprMergulhador[numMergulhador].posY = posicaoDuto1 end 
            if numMergulhador == 2 then sprMergulhador[numMergulhador].posY = posicaoDuto2 end 
            if numMergulhador == 3 then sprMergulhador[numMergulhador].posY = posicaoDuto3 end
            sprMergulhador[numMergulhador].posX      = -100
        end
    end
end

-- ## movimenta mergulhador ## --
function moveMergulhadores()
	for me = 0, table.maxn(sprMergulhador) do
        sprMergulhador[me]:AutoHorizontalMoviment(false)
        sprMergulhador[me]:putSprite()
        if not sprMergulhador[me].active then 
            dutoMergulhador[me] = false 
        end
	end
end
