Sound = {}
function Sound:new(fileSound,timePlaying)
  local obj = { fileSound=fileSound, soundPointer=0, timePlaying=timePlaying, soundActive=false, soundPlaying=false}
  setmetatable(obj, { __index = Sound })
  return obj
end
    -- ## Methods definition ## -- 
    -- ## load sound in memory ## --
    function Sound:Load()
        self.soundPointer = Mod.load(self.fileSound)
    end

    -- ## play sound ## --
    function Sound:Play()
        if self.soundActive then 
            self.soundActive = false
            Mod.play(self.soundPointer)
            self.soundPlaying = true
        end
        if self.soundPlaying and Mod.time(self.soundPointer) >= self.timePlaying then 
            Mod.setPosition(0)
            Mod.stop()
            self.soundPlaying = false
        end
    end

    -- ## sound destroy ## --
    function Sound:Destroy()
        Mod.destroy(self.soundPointer)
    end
